/* ddicΥåºݤ˹Ԥ
 */
#include <stdio.h>
#include <stdlib.h>
#include "ddic.h"
#include "ddic_tree.h"
#include "dic_session.h"

/*ؿã*/
/*̵ä0֤*/
static struct seq_node *alloc_seq_node_by_xstr(xstr *);
static int hash_function(xstr *x);
static void release_seq_ent(struct seq_ent se);
static void free_dic_ent(struct dic_ent *e);

/*FIXME ddicϰĤʤȲꤷƤ롣*/
static struct ddic_handle *g_ddic;

struct seq_node *alloc_seq_node_by_xstr(xstr *x)
{
  struct seq_node *s;
  int mask = get_current_session_mask();
  s = (struct seq_node *)malloc(sizeof(struct seq_node));
  s->data.dic_ents = 0;
  s->data.flags = F_NONE;
  s->data.nr_dic_ents = 0;
  s->data.node_type = 0;
  s->str.len = x->len;
  s->str.str = xstr_dup_str(x);
  s->mask = mask;
  if ( mask == 0){
    /*åʤnodeǤ롣*/
    printf("volatile dic node\n");
  }
  return s;
}

struct seq_ent *ddic_alloc_seq_ent_by_xstr(ddic_t d,xstr *x)
{
  struct seq_node *n;
  struct seq_ent *e;
  struct ddic_handle *dd=d;
  int h;
  /*åˤФ֤*/
  e = ddic_find_seq_ent_by_xstr(d,x);
  if ( e ){
    return e;
  }
  n = alloc_seq_node_by_xstr(x);

  h = hash_function(x);
  n->next = dd->root_node[h].next;
  dd->root_node[h].next = n;

  return &n->data;
}

struct seq_ent *ddic_find_seq_ent_by_xstr(ddic_t d,xstr *x)
{
  struct seq_node *c;
  struct ddic_handle *dh=d;
  int h;
  h = hash_function(x);
  for ( c = dh->root_node[h].next ; c ;c= c->next){
    if (!xstrcmp(&c->str,x)){
      int mask;
      mask = get_current_session_mask();
      c->mask |= mask;
      return &c->data;
    }
  }
  return 0;
}

void free_dic_ent(struct dic_ent *e)
{
  free(e->str.str);
  free(e);
}

void release_seq_ent(struct seq_ent se)
{
  int i;
  for ( i = 0 ; i < se.nr_dic_ents ; i++){
    free_dic_ent(se.dic_ents[i]);
  }
  free(se.dic_ents);
}

void ddic_release_seq_ent(ddic_t d,xstr *x)
{
  struct seq_node *c;
  struct ddic_handle *dh=d;
  int h;
  h = hash_function(x);
  for ( c = &dh->root_node[h] ; c->next ;  c= c->next){
    if (!xstrcmp(&c->next->str,x)){
      struct seq_node *p;
      p = c->next;
      if ( p->data.nr_dic_ents ){
	release_seq_ent(p->data);
	return ;
      }
      c->next = c->next->next;
      free(p->str.str);
      free(p);
      return ;
    }
  }
}

void invalidate_seq_node_mask(int mask)
{
  int i;
  struct seq_node *n;
  for ( i = 0 ; i < HASH_SIZE ; i++){
    for ( n = g_ddic->root_node[i].next; n ; n = n->next){
      n->mask &= mask;
    }
  }
}

void ddic_push_back_dic_ent(struct seq_ent *se,xstr *xs,wtype_t wt,int freq)
{
  struct dic_ent *de;
  de = malloc(sizeof(struct dic_ent));
  de->type = wt;
  de->freq = freq;
  de->str.len = xs->len;
  de->str.str = xstr_dup_str(xs);

  se->nr_dic_ents ++;
  se->dic_ents = realloc(se->dic_ents,
			sizeof(struct dic_ent *)*se->nr_dic_ents);
  se->dic_ents[se->nr_dic_ents-1] = de;
}

ddic_t create_ddic()
{
  int i;
  struct ddic_handle *de;
  de = (struct ddic_handle *)malloc(sizeof(struct ddic_handle));

  for(i=0 ; i<HASH_SIZE ; i++){
    de->root_node[i].next=0;
  }

  g_ddic = de;

  return de;
}

/*hash_function(xstr *x)  ϥåؿȤꤢƤȡ*/

int hash_function(xstr *x)
{
  if ( x->len ){
    return x->str[0]% 16;
  }
  return 0;
}

void shrink_ddic(ddic_t d)
{
  int i;
  struct seq_node *n;
  for ( i = 0 ; i < HASH_SIZE ; i ++){
    n = &d->root_node[i];
    for ( ; n && n->next ; n = n->next ){
      if ( ! n->next->mask ){
	struct seq_node *tmp;
	tmp = n->next;
	n->next = n->next->next;
	release_seq_ent(tmp->data);
	free(tmp->str.str);
	free(tmp);
      }
    }
  }
}
