/*
  ؽΥҥȥ
  */
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <conf.h>
#include <ruleparser.h>
#include <record.h>

/**/
struct record_val{
  xstr str;
  int val;
};

/**/
struct record_column{
  xstr key;
  int nr_vals;
  struct record_val *vals;
  struct record_column *next;
};

/**/
struct record_section{
  char *name;
  struct record_column cols;
  struct record_section *next;
};

/*ǡ١*/
struct record_stat{
  struct record_section section;
  struct record_section *cur_section;
  struct record_column *cur_column;
  int is_dirty;
}gR;

static void read_last_session();
static void read_session();
static void check_anthy_dir();
static void mk_dirty();
static void save_a_column(FILE *fp,struct record_column *);
static FILE *fopen_in_recorddir(char *,char *);
static void update_session_file();
static void free_record();
static void free_section(struct record_section *rs);
static void free_column(struct record_column *rc);
static struct record_val *get_nth_val_ent(int ,int create_if_not_exist);

FILE *fopen_in_recorddir(char *fn,char *mode)
{
  char *pn;
  char *hd;
  hd = conf_get_str("HOME");
  pn = alloca(strlen(hd)+strlen(fn)+10);
  strcpy(pn,hd);
  strcat(pn,"/.anthy/");
  strcat(pn,fn);
  return fopen(pn,mode);
}

void mk_dirty()
{
  gR.is_dirty = 1;
}

int select_section(char *name,int flag)
{
  struct record_section *rs;
  for ( rs = gR.section.next ;rs ; rs = rs->next ){
    if ( ! strcmp(name,rs->name)){
      gR.cur_section = rs;
      return 0;
    }
  }
  if ( flag ){
    rs = malloc(sizeof(struct record_section));
    rs->name = strdup(name);
    rs->next = gR.section.next;
    rs->cols.next = 0;
    gR.section.next = rs;
    gR.cur_section = rs;
    return 0;
  }
  return -1;
}

int select_column(xstr *name,int flag)
{
  struct record_column *col;
  if ( !gR.cur_section ){
    return -1;
  }
  for ( col = gR.cur_section->cols.next ; col; col = col->next ){
    if (! xstrcmp(&col->key,name)){
      gR.cur_column = col;
      return 0;
    }
  }
  if ( flag ){
    col = malloc(sizeof(struct record_column));
    col->key.str = xstr_dup_str(name);
    col->key.len = name->len;
    col->next = gR.cur_section->cols.next;
    col->nr_vals = 0;
    col->vals = 0;
    gR.cur_section->cols.next = col;
    gR.cur_column = col;
    mk_dirty();
    return 0;
  }
  return -1;
}

int select_first_column()
{
  if ( !gR.cur_section ){
    return -1;
  }
  if ( !gR.cur_section->cols.next ){
    return -1;
  }
  gR.cur_column = gR.cur_section->cols.next;
  return 0;
}

int select_next_column()
{
  if ( !gR.cur_column || !gR.cur_column->next ){
    return -1;
  }
  gR.cur_column = gR.cur_column->next;
  return 0;
}

/*column*/
void free_column(struct record_column *rc)
{
  int i;
  for ( i = 0 ; i < rc->nr_vals ; i++){
    if ( rc->vals[i].str.str ){
      free(rc->vals[i].str.str );
    }
  }
  free(rc->vals);
  if ( gR.cur_column == rc ){
    gR.cur_column = 0;
  }
  free(rc->key.str);
  free(rc);
}

/*륻ΥǡƲ*/
void free_section(struct record_section *rs)
{
  struct record_column *rc;
  for ( rc = rs->cols.next ; rc ; ){
    struct record_column *tmp;
    tmp = rc;
    rc = rc->next;
    free_column(tmp);
  }
  if ( gR.cur_section == rs ){
    gR.cur_section = 0;
  }
  if ( rs->name ){
    free(rs->name);
  }
  free(rs);
}

/*٤ƤΥǡ*/
void free_record()
{
  struct record_section *rs;
  for ( rs = gR.section.next ; rs ; ){
    struct record_section *tmp;
    tmp = rs;
    rs = rs->next;
    free_section(tmp);
  }
}

struct record_val *get_nth_val_ent(int n,int f)
{
  struct record_column *col = gR.cur_column;
  if ( !col ){
    return 0;
  }
  if ( n < get_nr_values() ){
    return &col->vals[n];
  }
  if ( f ){
    int i;
    col->vals = realloc(col->vals,sizeof(struct record_val)*(n+1));
    for ( i = col->nr_vals ; i < n+1 ; i++){
      col->vals[i].val = 0;
      col->vals[i].str.str = 0;
      col->vals[i].str.len = 0;
    }
    gR.cur_column->nr_vals = n+1;
    return &gR.cur_column->vals[n];
  }
  return 0;
}

int get_nr_values()
{
  if ( gR.cur_column ){
    return gR.cur_column->nr_vals;
  }
  return 0;
}

int get_nth_value(int n)
{
  struct record_val *v = get_nth_val_ent(n,0);
  if ( v ){
    return v->val;
  }
  return 0;
}

xstr *get_nth_xstr(int n)
{
  struct record_val *v = get_nth_val_ent(n,0);
  if ( v && v->str.str ){
    return &v->str;
  }
  return 0;
}

void set_nth_value(int nth,int val)
{
  struct record_val *v = get_nth_val_ent(nth,1);
  if ( !v ){
    return ;
  }
  mk_dirty();
  v->val = val;
}

void set_nth_xstr(int nth,xstr *xs)
{
  struct record_val *v = get_nth_val_ent(nth,1);
  if ( !v ){
    return ;
  }
  if ( v->str.str ){
    free(v->str.str);
  }
  v->str.str = xstr_dup_str(xs);
  v->str.len = xs->len;
  mk_dirty();
}

void release_column()
{
  struct record_column *rc;
  if ( ! gR.cur_section || !gR.cur_column){
    return ;
  }
  for ( rc = &gR.cur_section->cols ; rc->next ; rc = rc->next){
    if ( rc->next == gR.cur_column ){
      struct record_column *tmp;
      tmp = rc->next->next;
      free_column(rc->next);
      rc->next = tmp;
      return ;
    }
  }
}

void check_anthy_dir()
{
  char *hd;
  char *dn;
  struct stat st;
  hd = conf_get_str("HOME");
  dn = alloca(strlen(hd)+10);
  strcpy(dn,hd);
  strcat(dn,"/.anthy/");
  if ( stat(dn,&st) || !S_ISDIR(st.st_mode)){
    int r;
    printf("Failed to open anthy directory(%s).\n",dn);
    r = mkdir(dn,S_IRWXU);
    if ( r == -1){
      printf("Failed to create\n");
      return ;
    }
    printf("Created\n");
    r = chmod(dn,S_IRUSR|S_IWUSR|S_IXUSR);
    if ( r == -1 ){
      printf("But failed to change permission.\n");
    }
  }
}

void read_session()
{
    char **tokens;
    int nr;
    int s = 0;
    while(!read_line(&tokens,&nr)){
        if ( !strcmp(tokens[0],"---") && nr >1){
            s = 1;
            select_section(tokens[1],1);
        }else if ( s == 1 && nr>1){
            xstr *xs;
            int i;
            xs = cstr_to_xstr(tokens[0]);
            select_column(xs,1);
            free_xstr(xs);
            for ( i = 1 ; i < nr ; i++){
                if ( tokens[i][0] == '"' ){
                    char *str;
                    str = strdup(&tokens[i][1]);
                    str[strlen(str)-1] = 0;
                    xs = cstr_to_xstr(str);
                    free(str);
                    set_nth_xstr(i-1,xs);
                    free_xstr(xs);
                }else{
                    set_nth_value(i-i,atoi(tokens[i]));
                }
            }
        }
        free_line();
    }
    close_file();
}

void read_last_session()
{
  char *pn,*hd;
  check_anthy_dir();
  hd = conf_get_str("HOME");
  pn = alloca(strlen(hd)+strlen("/.anthy/last-record")+1);
  strcpy(pn,hd);
  strcat(pn,"/.anthy/last-record");
  if ( open_file(pn) == 0 ){
      free_record();
      read_session();
  }
}

void update_session_file()
{
  char *hd,*fn1,*fn2;
  char *sid;
  hd = conf_get_str("HOME");
  sid = conf_get_str("SESSION-ID");
  fn1 = alloca(strlen(hd)+strlen(sid)+10);
  fn2 = alloca(strlen(hd)+20);
  strcpy(fn1,hd);
  strcat(fn1,"/.anthy/");
  strcat(fn1,sid);
  strcpy(fn2,hd);
  strcat(fn2,"/.anthy/last-record");
  if ( rename(fn1,fn2) ){
    printf("failed to update record file.\n");
  }
}

void save_a_column(FILE *fp,struct record_column *c)
{
  int i;
  char *buf = malloc(c->key.len *2 +2);
  sputxstr(buf,&c->key);
  fprintf(fp,"%s ",buf);
  for ( i = 0 ; i < c->nr_vals ; i++){
    struct record_val *val = &c->vals[i];
    if ( val->str.str ){
      buf = realloc(buf,val->str.len*2+2);
      sputxstr(buf,&val->str);
      fprintf(fp,"\"%s\" ",buf);
    }else{
      fprintf(fp,"%d ",val->val);
    }
  }
  fprintf(fp,"\n");
  free(buf);
}

void save_record()
{
  struct record_section *sec;
  struct record_column *col;
  char *sid;
  FILE *fp;
  if ( !gR.is_dirty ){
    return ;
  }
  sid = conf_get_str("SESSION-ID");
  fp = fopen_in_recorddir(sid,"w");
  if ( ! fp ){
    printf("failed to open temporaly session file.\n");
    return ;
  }
  for ( sec = gR.section.next ; sec ; sec = sec->next ){
    if ( !sec->cols.next ){
      /*Υ϶*/
      continue;
    }
    fprintf(fp,"--- %s\n",sec->name);
    for ( col = sec->cols.next ; col ; col = col->next ){
      save_a_column(fp,col);
    }
  }
  fclose(fp);
  gR.is_dirty = 0;
  update_session_file();
}

void init_record()
{
  read_last_session();
  gR.is_dirty = 0;
}
