/*
  ѤΥեɤ߹ߥ롼
 */
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <conf.h>
#include <ruleparser.h>

/*ʸˡեΥѡѤ*/
#define MAX_TOKEN_LEN 256
/*Υ󥯥롼ɤο*/
#define MAX_INCLUDE_DEPTH 4

#define PS_INIT 0
#define PS_TOKEN 1
#define PS_EOF 2
#define PS_RET 3
#define PS_BSLASH 4

#define NL "NL"

static struct ParserStat{
  FILE *fp_stack[MAX_INCLUDE_DEPTH];
  FILE *fp;
  char **tokens;
  int nr_token;
  int cur_fpp;/*åΥǥå*/
  int buf_index;
  int stat;
  char buf[MAX_TOKEN_LEN];
}g_ps;

/*ѡ*/
static char *get_token_in();
static int get_line_in();
static void get_line();
static void proc_include();
static void pop_file();

FILE *open_file_in_confdir(char *fn)
{
  char *dn;
  char *full;
  if ( fn[0] == '/' ){
      return fopen(fn,"r");
  }
  dn = conf_get_str("ANTHYDIR");
  if (!dn ){
    return 0;
  }
  full = alloca(strlen(dn)+strlen(fn)+2);
  strcpy(full,dn);
  strcat(full,"/");
  strcat(full,fn);
  return fopen(full,"r");
}

char *get_token_in()
{
  int cc;
again:
  switch(g_ps.stat){
  case PS_INIT:
  {
    cc = fgetc(g_ps.fp);
    if (cc == -1){
      return 0;
    }
    if ( cc == '\n'){
      return NL;
    }
    if ( cc == '\\' ){
      g_ps.stat = PS_BSLASH;
    }
    if ( isspace(cc)){
      goto again;
    }
    g_ps.stat = PS_TOKEN;
    g_ps.buf[0] = cc;
    g_ps.buf_index =1;
    goto again;
  }
  break;
  case PS_TOKEN:
  {
    cc = fgetc(g_ps.fp);
    if ( cc == -1){
      g_ps.buf[g_ps.buf_index] = 0;
      g_ps.stat = PS_EOF;
      return g_ps.buf;
    }
    if ( cc == '\n'){
      g_ps.buf[g_ps.buf_index] = 0;
      g_ps.stat = PS_RET;
      return g_ps.buf;
    }
    if ( isspace(cc)){
      g_ps.buf[g_ps.buf_index] = 0;
      g_ps.stat = PS_INIT;
      return g_ps.buf;
    }
    g_ps.buf[g_ps.buf_index]= cc;
    g_ps.buf_index ++;
    goto again;
  }
  break;
  case PS_BSLASH:
  {
    cc = fgetc(g_ps.fp);
  }
  break;
  case PS_EOF:
  {
    return 0;
  }
  case PS_RET:
  {
    g_ps.stat = PS_INIT;
    return NL;
  }
  }
  return 0;
}

int get_line_in()
{
  char *t;
  do{
    t = get_token_in();
    if ( !t){
      return -1;
    }
    if ( t == NL ){
      return 0;
    }
    g_ps.nr_token++;
    g_ps.tokens = realloc(g_ps.tokens,sizeof(char *)*g_ps.nr_token);
    g_ps.tokens[g_ps.nr_token-1] = strdup(t);
  }while(1);
}

void proc_include()
{
  FILE *fp;
  if ( g_ps.nr_token != 2){
    printf("Syntax error.\n");
    return ;
  }
  if ( g_ps.cur_fpp > MAX_INCLUDE_DEPTH -1){
    printf("Too deep include.\n");
    return ;
  }
  fp = open_file_in_confdir(g_ps.tokens[1]);
  if ( ! fp ){
    printf("Failed to open.\n");
    return ;
  }
  g_ps.cur_fpp++;
  g_ps.fp_stack[g_ps.cur_fpp] = fp;
  g_ps.fp = fp;
}

/*󥯥롼ɤΥͥȤ򲼤*/
void pop_file()
{
  fclose(g_ps.fp);
  g_ps.cur_fpp --;
  g_ps.fp = g_ps.fp_stack[g_ps.cur_fpp];
}

void get_line()
{
  int ok=0;
  do{
    int r;
    free_line();
    g_ps.nr_token = 0;
    g_ps.stat = PS_INIT;
    r = get_line_in();
    if ( r == -1){
      /*EOFǤʾɤ*/
      if ( g_ps.cur_fpp > 0 ){
	pop_file();
      }else{
	ok = 1;
      }
    }else if (g_ps.nr_token ){
      if ( !strcmp(g_ps.tokens[0],"\\include")){
	proc_include();
      }else if (!strcmp(g_ps.tokens[0],"\\eof")){
	if ( g_ps.cur_fpp > 0 ){
	  pop_file();
	}else{
	  free_line();
	  ok = 1;
	}
      }else if (g_ps.tokens[0][0] != '#'){
	ok = 1;
      }
    }
  }while(!ok);
}

void free_line()
{
  int i;
  for ( i = 0 ; i < g_ps.nr_token ; i++){
    free(g_ps.tokens[i]);
  }
  free(g_ps.tokens);
  g_ps.tokens = 0;
  g_ps.nr_token = 0;
}

int open_file(char *fn)
{
  g_ps.fp_stack[0] = open_file_in_confdir(fn);
  if (! g_ps.fp_stack[0] ){
    return -1;
  }
  /*ѡ*/
  g_ps.stat = PS_INIT;
  g_ps.cur_fpp = 0;
  g_ps.fp = g_ps.fp_stack[0];
  g_ps.tokens = 0;
  g_ps.nr_token = 0;
  return 0;
}

void close_file()
{
  fclose(g_ps.fp);
}

int read_line(char ***tokens,int *nr)
{
  get_line();
  *tokens = g_ps.tokens;
  *nr = g_ps.nr_token;
  if (!*nr){
    return -1;
  }
  return 0;
}
