/*
  Static Dictionary
  եμΥ󥿡ե¸ߤǡ
  å夵ΤǤǤ¸ߤʤñ
  ®ˤɬפ롣
 */
#include <dlfcn.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <xstr.h>
#include "sdic.h"

/*mkdic.cƱΤ*/
char *index_tab="0123456789abcdefghijklmnopqrstuvwxyz";

#define HASH_SHIFT 5
#define HASH_ARRAY 16384
#define HASH_BIT (1<<HASH_SHIFT)

struct sdic_ent{
  int off;
  char *str;
}*ent;

struct sdic_page{
  xstr str;
  int len_hist;/*ñĹΥҥȥ*/
};

struct sdic_handle{
  struct sdic_ent *index;
  struct sdic_page *pages;
  int len_hist;
  char **ent;
  int nr_pages;
  void *dh;/*shared objectΥϥɥ*/
  int hash_ent[HASH_ARRAY];
};

static void make_dic_index(struct sdic_handle *);
static void extract_page(struct sdic_handle *,struct sdic_page *,char *);
static int get_page_index(struct sdic_handle *,xstr *);
static int get_page_index_search(struct sdic_handle *,xstr *,int,int);
/*x1<x2ʤx1>x2ʤ֤*/
static int ordered_xstrcmp(xstr *x1,xstr *x2);
static int search_word_in_page(xstr *,char *);
static int search_word(struct sdic_handle *s,xstr *x);
static int mkxstr(char *s,xstr *x);
static int get_index_from_char(char );
static void fill_dic_ent(struct sdic_handle *s,int x,
			 struct seq_ent *,xstr *eow,int cc,int ct,int cst);
static int parse_wtype(char *,wtype_t *,int *);
static int add_dic_ent(struct seq_ent *,wtype_t *,int freq,char *,
		       xstr *eow,int cc,int ct,int cst);
static void push_back_dic_ent(struct seq_ent *,wtype_t,int,xstr,
			      xstr *eow,int ct,int cst);
static int hash(xstr *);
static void mark_hash_ent(struct sdic_handle *h,int val);
static int get_hash_ent(struct sdic_handle *h,int val);

static int hash(xstr *x)
{
  int h,i;
  h = 0;
  for ( i = 0 ;i < x->len ;i++){
    h *= 23;
    h -= x->str[i];
  }
  return h&(HASH_ARRAY*HASH_BIT-1);
}

void mark_hash_ent(struct sdic_handle *h,int val)
{
  int idx=(val>>HASH_SHIFT)&(HASH_ARRAY-1);
  int bit= val & ((1<<HASH_SHIFT)-1);
  h->hash_ent[idx] |= (1<<bit);
}

int get_hash_ent(struct sdic_handle *h,int val)
{
  int idx=(val>>HASH_SHIFT)&(HASH_ARRAY-1);
  int bit= val & ((1<<HASH_SHIFT)-1);
  return h->hash_ent[idx] & (1<<bit);
}

void push_back_dic_ent(struct seq_ent *s,wtype_t w,int freq,xstr x,
		       xstr *eow,int ct,int cst)
{
  xstr *xs;
  wtype_set_ct(&w,ct);
  wtype_set_cst(&w,cst);
  if ( wtype_get_pos(w) == POS_AJV && ct == CT_NONE){
    /*ư츶ʤ̾˽񴹤*/
    wtype_set_pos(&w,POS_NOUN);
  }
  if ( wtype_get_ct(w) != CT_SYUSI &&wtype_get_ct(w) != CT_NONE){
    freq /= 2;
  }

  xs = xstr_dup(&x);
  if ( eow ){
    /*Ѹɲ*/
    xstrcat(xs,eow);
  }

  ddic_push_back_dic_ent(s,xs,w,freq);
}

/* #XX*123 ȤCannadicηѡ
 ֤ͤϲʸɤߤ*/
int parse_wtype(char *s,wtype_t *t,int *f)
{
  int i,j;
  char buff1[10];/*ʻ*/
  char buff2[10];/**/
  for ( i = 0 , j= -1; s[i] && s[i]!= ' ' ; i++){
    if ( j == -1 ){
      if ( s[i] == '*' ){
	buff1[i]=0;
	j=0;
      }else{
	buff1[i] = s[i];
      }
    }else{
      buff2[j] = s[i];
      j++;
    }
  }
  if ( j >= 0 ){
    buff2[j] = 0;
    *f = atoi(buff2)*8;
  }else{
    buff1[i] = 0;
    *f = 1;
  }
  type_to_wtype(buff1,t);
  return i;
}

int add_dic_ent(struct seq_ent *e,wtype_t *wt,int freq,char *s,
		xstr *eow,int cc,int ct,int cst)
{
  int i,j;
  char *buf;
  xstr *xs;
  /*ʸ׻*/
  for ( i = 0 ; s[i] && (s[i] != ' ') && (s[i]!='#'); i++);
  buf = alloca(i+1);
  buf[i] = 0;
  for ( j = 0 ; j < i ; j++){
    buf[j] = s[j];
  }
  xs = cstr_to_xstr(buf);
  if ( cc == wtype_get_cc(*wt) && 
       wtype_get_pos(*wt) != POS_INVAL &&
       (ct == wtype_get_ct(*wt)||
	 CT_NONE == wtype_get_ct(*wt))){
    /*ꤵƤѷ򤷤Ƥ*/
    push_back_dic_ent(e,*wt,freq,*xs,eow,ct,cst);
  }
  free_xstr(xs);
  return i;
}

void fill_dic_ent(struct sdic_handle *s,int x,struct seq_ent *ent,
		  xstr *eow,int cc,int ct,int cst)
{
  char *e;
  wtype_t wt;/*ʻ*/
  int freq;
  int c=0;
  e = s->ent[x];
  while(e[c]){
    if ( e[c] == '#'){
      c+= parse_wtype(&e[c],&wt,&freq);
    }else{
      c+= add_dic_ent(ent,&wt,freq,&e[c],eow,cc,ct,cst);
    }
    if ( e[c] == ' '){
      c++;
    }
  }
}

int get_index_from_char(char s)
{
  int i;
  for ( i = 0 ; i < 36 ; i++){
    if ( s == index_tab[i] ){
      return i;
    }
  }
  return -1;
}

int mkxstr(char *s,xstr *x)
{
  int i;
  /*s[0]ˤϴᤷʸ*/
  x->len -=get_index_from_char(s[0]);
  for ( i = 1 ; s[i]<0 ; i+=2){
    unsigned char h,l;
    l = s[i];
    h = s[i+1];
    x->str[x->len] = (l*256)+h;
    x->len++;
  } 
  return i;
}

int search_word_in_page(xstr *x,char *s)
{
  int o=0;
  xchar *buf;
  xstr xs;
  /*ΥڡˤäȤĹñǼĹ*/
  buf = alloca(sizeof(xchar)*strlen(s)/2);
  xs.str = buf;
  xs.len = 0;
  while(*s){
    s+=mkxstr(s,&xs);
    if (! ordered_xstrcmp(&xs,x)){
      return o;
    }
    o ++;
  }
  return -1;
}

int ordered_xstrcmp(xstr *x1,xstr *x2)
{
  int i,m;
  if ( x1->len < x2->len ){
    m = x1->len;
  }else{
    m = x2->len;
  }
  for ( i = 0 ; i < m ; i++){
    if ( x1->str[i] < x2->str[i] ){
      return 1;
    }
    if ( x1->str[i] > x2->str[i] ){
      return -1;
    }
  }
  if ( x1->len < x2->len ){
    return 1;
  }
  if ( x1->len > x2->len ){
    return -1;
  }
  return 0;
}

int get_page_index_search(struct sdic_handle *s,xstr *x,int f,int t)
{
  /*ordered_xstrcmp-1̵ʤäȤõ*/
  int c,p;
  c = (f+t)/2;
  p = ordered_xstrcmp(x,&s->pages[c].str);
  if ( p == 1){
    /*f<= <=c*/
    if ( f == c-1){
      if ( ordered_xstrcmp(x,&s->pages[c-1].str) < 1){
	return c-1;
      }
    }
    return get_page_index_search(s,x,f,c+1);
  }
  if ( p == -1 ){
    /* c<= <t*/
    return get_page_index_search(s,x,c,t);
  }
  return c;
}

int get_page_index(struct sdic_handle *s,xstr *x)
{
  if ( ordered_xstrcmp(x,&s->pages[0].str) == 1){
    return -1;
  }
  if ( ordered_xstrcmp(x,&s->pages[s->nr_pages-1].str) <= 0 ){
    return s->nr_pages-1;
  }
  return get_page_index_search(s,x,0,s->nr_pages);
}

void extract_page(struct sdic_handle *h,struct sdic_page *p,char *s)
{
  int i;
  xstr *x = &p->str;
  xstr y;
  p->len_hist = 0;
  /*ʸĹ*/
  s++;
  for ( i = 0 ; s[i] < 0 ; i+=2);
  /*򥳥ԡ*/
  x->len = i/2;
  x->str = malloc(sizeof(xchar)*i/2);
  for ( i = 0 ; i < x->len ; i++){
    unsigned char h,l;
    l = s[i*2+1];
    h = s[i*2];
    x->str[i] = (h*256)+ l;
  }
  /**/
  s--;
  y.str = alloca(sizeof(xchar)*strlen(s)/2);
  y.len = 0;
  while(*s){
    s+= mkxstr(s,&y);
    mark_hash_ent(h,hash(&y));
    p->len_hist |= (1<< y.len);
  }
}

int get_nr_page(struct sdic_handle *h)
{
  int i;
  for ( i = 0 ; h->index[i].str[2] ; i++);
  return i;
}

void make_dic_index(struct sdic_handle *h)
{
  int i;
  h->nr_pages = get_nr_page(h);
  h->pages = malloc(sizeof(struct sdic_page)*h->nr_pages);
  h->len_hist = 0;
  for ( i = 0 ; i < h->nr_pages ; i++){
    extract_page(h,&h->pages[i],h->index[i].str);
    h->len_hist |= h->pages[i].len_hist;
  }
}

struct sdic_handle *create_sdic(char *fn)
{
  struct sdic_handle *h;
  int i;
  h = malloc(sizeof(struct sdic_handle));
  for ( i = 0 ; i < HASH_ARRAY ; i++){
    h->hash_ent[i]= 0;
  }
  h->dh = dlopen(fn,RTLD_NOW);
  if (! h->dh){
    free(h);
    return 0;
  }
  h->index = dlsym(h->dh,"index");
  if ( !h->index){
    dlclose(h->dh);
    free(h);
    return 0;
  }
  h->ent = dlsym(h->dh,"ent");
  if ( !h->ent){
    dlclose(h->ent);
    free(h);
    return 0;
  }
  make_dic_index(h);
  return h;
}

int search_word(struct sdic_handle *e,xstr *x)
{
  int p,o;
  p = get_page_index(e,x);
  if ( p == -1){
    return -1;
  }
  if (! (( 1<< x->len) & (e->pages[p].len_hist))){
    return -1;
  }
  o = search_word_in_page(x,e->index[p].str);
  if ( o == -1 ){
    return -1;
  }
  /*mkdic.cWORDS_PER_PAGE = 64*/
  return o+p*64;
}

void sdic_fill_seq_ent_by_xstr(sdic_t s,xstr *x,struct seq_ent *e,
			       xstr *eow,int cc,int ct,int cst)
{
  int i;
  /*ʸñϼ̵*/
  if ( !((1 << x->len ) & s->len_hist) ){
    /*32ʸʾΤĤ⾡˽*/
    return;
  }
  if (!get_hash_ent(s,hash(x))){
    return ;
  }
  i = search_word(s,x);
  if ( i >= 0){
    e->node_type |= ST_WORD;
    fill_dic_ent(s,i,e,eow,cc,ct,cst);
  }
}

int init_sdic()
{
  return 0;
}
