/*
  cannadicΥե뤫鼭Υ
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdlib.h>

#include <xstr.h>
#include <wtype.h>

#define MAX_LINE_LEN 1024
#define WORDS_PER_PAGE 64

#define DEFAULT_FN "anthy.dic"
char *output_fn = DEFAULT_FN;

/*ieϤ줾index,entry*/
FILE *i_out,*e_out;
int nr_page;

char *index_tab="0123456789abcdefghijklmnopqrstuvwxyz";

void open_output_files()
{
  char *fnbuf;
  fnbuf = alloca(strlen(output_fn)+10);

  strcpy(fnbuf,output_fn);
  strcat(fnbuf,".index.c");
  i_out = fopen(fnbuf,"w");
  strcpy(fnbuf,output_fn);
  strcat(fnbuf,".entry.c");
  e_out = fopen(fnbuf,"w");
  if (!i_out || !e_out){
    printf("failed to open file\n");
    exit(0);
  }
}

/*2ĤʸζʬĹ*/
int common_len(xstr *s1,xstr *s2)
{
  int m,i;
  if ( !s1 || !s2 ){
    return 0;
  }
  if ( s1->len < s2->len ){
    m = s1->len;
  }else{
    m = s2->len;
  }
  for ( i = 0 ; i < m ; i++){
    if ( s1->str[i] != s2->str[i]){
      return i;
    }
  }
  return m;
}

void output_diff(xstr *p,xstr *c)
{
  int i,m;
  m = common_len(p,c);
  fprintf(i_out,"\"");
  if ( p && p->len > m ){
    fprintf(i_out,"%c",index_tab[p->len-m]);
  }else{
    fprintf(i_out,"%c",index_tab[0]);
  }
  for ( i = m ; i < c-> len ; i++){
    char buf[3];
    sputxchar(buf,c->str[i]);
    fprintf(i_out,buf);
  }
  fprintf(i_out,"\"\n");
}

void begin_dic_entry()
{
  fprintf(e_out,"\"");
}

void end_dic_entry()
{
  fprintf(e_out,"\",\n");
}

int mk_dic_entry(char *lbuf)
{
  char *p;
  char buf2[MAX_LINE_LEN];
  char *buf = buf2;
  int nr = 0;
  strcpy(buf,lbuf);
  buf[strlen(buf)-1] = 0;
  while((p = strsep(&buf," "))){
    if ( p[0] == '#'){
      fprintf(e_out,p);
    }else {
      if ( nr ){
	fprintf(e_out," %s",p);
      }
      nr ++;
    }
  }
  return nr;
}

int write_a_page()
{
  int i;
  char lbuf[MAX_LINE_LEN];
  char buf[MAX_LINE_LEN];
  xstr *prev,*cur;
  int f = 0;
  prev = 0;
  nr_page++;
  for ( i = 0 ; i <  WORDS_PER_PAGE ; i++){
  reread:
    if ( !fgets(lbuf,MAX_LINE_LEN,stdin)){
      /*ѥǥ󥰤*/
      printf("end\n");
      end_dic_entry();
      return -1;
    }else if ( sscanf(lbuf,"%s",buf) == 1){
      if ( (lbuf[0] == '#')){
	/*ȹԤȤФ*/
	goto reread;
      }
      cur = cstr_to_xstr(buf);
      if ( prev && !xstrcmp(prev,cur)){
	mk_dic_entry(lbuf);
	putxstr(prev);
	printf(" reread\n");
	goto reread;
      }else{
	int j;
	for ( j = 0 ; j < cur->len ; j++){
	  if ( strchr(index_tab,cur->str[j])){
	    putxstr(cur);
	    printf(" discard\n");
	    free_xstr(cur);
	    goto reread;
	  }
	}
	if (f ){
	  end_dic_entry();
	}
	begin_dic_entry();
	f = 1;
	mk_dic_entry(lbuf);
      }
      output_diff(prev,cur);
      if ( prev ){
	free_xstr(prev);
      }
      prev = cur;
    }else{
      /**/
      printf("Syntax error in dictionary file\n");
      exit(0);
    }
  }
  end_dic_entry();
  return 0;
}

void write_pages()
{
  int r=0;
  while(!r){
    fprintf(i_out,
	    "{\n0,\n"
      );
    r = write_a_page();
    fprintf(i_out,"},\n");
  }
  /*ǽڡ*/
  fprintf(i_out,"{0,\"00\"}\n");
  fprintf(i_out,
    "};\n");
}

void print_usage()
{
  printf("please use mkanthydic command.\n");
  exit(0);
}

void parse_args(int argc,char **argv)
{
  int i;
  for ( i = 1 ; i < argc ; i++){
    if ( !strcmp(argv[i],"--help")){
      print_usage();
    }
    if ( i +1 < argc && !strcmp(argv[i],"-o")){
      output_fn = argv[i+1];
      i++;
    }
  }
  open_output_files();
}

int main(int argc,char **argv)
{
  parse_args(argc,argv);
  fprintf(i_out,
	  "struct {\n"
	  " int off;\n"
	  " char *str;\n"
	  "}index[]={\n");
  fprintf(e_out,
	  "char *ent[]={\n");
  write_pages();
  fprintf(e_out,
	  "};\n");
  fprintf(i_out,"/*%d segments*/\n",nr_page);
  return 0;
}
