/*
  AnthyΥƥȤФƤƤФ롣
  ФѴѥץ饤ɬפʥ⥸塼˸ƤӤ
  */
#include <stdlib.h>
#include <stdio.h>

#include <record.h>
#include "main.h"
#include "context.h"

static void pop_back_seg_ent(struct anthy_context *c);
static int get_nth_segment_index(struct anthy_context *c,int sindex);

struct anthy_context *create_context()
{
  struct anthy_context *ac;
  dic_session_t ds = dic_create_session();
  if ( !ds ){
    return 0;
  }
  ac = (struct anthy_context *)malloc(sizeof(struct anthy_context));
  ac->str = 0;
  ac->ce = 0;
  ac->seg_count = 0;
  ac->seg_list.prev = &ac->seg_list;
  ac->seg_list.next = &ac->seg_list;
  ac->dic_session = ds;
  ac->word_split_info = 0;
  return ac;
}

void reset_context(struct anthy_context *c)
{
  int i,sc;
  release_word_split_info(c);
  if ( c->str ){
    free(c->str);
    c->str = 0;
  }
  if ( c->ce ){
    free(c->ce);
    c->ce = 0;
  }
  sc = c->seg_count;
  for ( i = 0 ; i < sc ; i++){
    pop_back_seg_ent(c);
  }
  c->seg_count = 0;
  if ( c->dic_session ){
    dic_release_session(c->dic_session);
    c->dic_session = 0;
  }
  save_record();
}

void release_context(struct anthy_context *c)
{
  reset_context(c);
  free(c);
}

void context_set_str(struct anthy_context *c,xstr *s)
{
  int i,sc;

  /**/
  reset_context(c);

  /*񥻥åγ*/
  if ( ! c->dic_session ){
    c->dic_session = dic_create_session();
  }
  dic_activate_session(c->dic_session);

  /*Хåեγ*/
  c->char_count = s->len;
  c->str = (xchar *)malloc(sizeof(xchar)*(s->len+1));
  c->ce = (struct char_ent*)malloc(sizeof(struct char_ent)*(s->len+1));
  sc = c->seg_count;
  for ( i = 0 ; i < sc ; i++){
    pop_back_seg_ent(c);
  }
  for ( i = 0 ; i < c->char_count ; i++){
    c->str[i] = s->str[i];
    c->ce[i].c = &c->str[i];
    c->ce[i].seg_border = 0;
  }

  /*ξüñ춭ǤꡢʸζǤ롣*/
  c->ce[0].seg_border = 1;
  c->str[i] = 0;
  c->ce[i].c =  &c->str[i];
  c->ce[i].seg_border = 1;

  /*ʸζ*/
  mark_border(c,0,0,i);

  /**/
  for ( i = 0 ; i < c->seg_count ;i++){
    make_candidates(c,get_nth_segment(c,i));
  }

  /*򥽡*/
  sort_candidate(c,0);
}

void context_resize_segment(struct anthy_context *c,int nth,int resize)
{
  int i;
  int index,len,sc;

  /*resizeǽ*/
  if ( nth >= c->seg_count){
    return ;
  }
  index = get_nth_segment_index(c,nth);
  len = get_nth_segment_len(c,nth);
  if (index + len + resize > c->char_count ){
    return ;
  }
  if ( len + resize < 1){
    return ;
  }

  /*nthʹߤseg_ent*/
  sc = c->seg_count;
  for ( i = nth ; i < sc ; i++){
    pop_back_seg_ent(c);
  }

  /*resizeseg_borderޡ*/
  /*ߤΥޡäƿޡĤ*/
  c->ce[index+len].seg_border = 0;
  c->ce[index+len+resize].seg_border = 1;
  c->ce[c->char_count].seg_border = 1;
  for ( i = index+len+resize+1 ; i < c->char_count ; i++){
    c->ce[i].seg_border = 0;
  }
  
  /*word_split򤹤*/
  c->ce[index+len+resize].seg_border = 1;
  /*index  index +len+resizeδ֤˶뤳Ȥػߤ*/
  mark_border(c,index,index+len+resize,c->char_count);

  /**/
  for ( i = nth ; i < c->seg_count ;i++){
    make_candidates(c,get_nth_segment(c,i));
  }
  /*򥽡*/
  sort_candidate(c,nth);
}

void push_back_segment(struct anthy_context *c,struct seg_ent *s)
{
  s->next = &c->seg_list;
  s->prev = c->seg_list.prev;
  c->seg_list.prev->next = s;
  c->seg_list.prev = s;
  c->seg_count ++;
  s->commit = -1;
}

int get_nth_segment_index(struct anthy_context *c,int n)
{
  int i,s;
  for ( i = 0,s = 0 ; i < c->char_count ; i++){
    if ( c->ce[i].seg_border ){
      if ( s == n){
	return i;
      }
      s++;
    }
  }
  return -1;
}

int get_nth_segment_len(struct anthy_context *c,int sindex)
{
  int a,i,l;
  a = get_nth_segment_index(c,sindex);
  if ( a == -1){
    return -1;
  }
  l = 1;
  for ( i = a+1 ; !c->ce[i].seg_border ; i++){
    l++;
  }
  return l;
}

struct seg_ent *get_nth_segment(struct anthy_context *ac,int n)
{
  int i;
  struct seg_ent *se;
  if ( n >= ac->seg_count ){
    return 0;
  }
  for ( i = 0,se = ac->seg_list.next ; i < n ; i++ ,se = se->next);
  return se;
}

void print_context(struct anthy_context *c)
{
  int i;
  struct char_ent *ce;
  ce = c->ce;
  for ( i = 0 ,ce =c->ce; i < c->char_count ; i++,ce++){
    if ( ce->seg_border ){
      printf("|");
    }
    putxchar(*(ce->c));
  }
  printf("\n");
  for ( i = 0 ; i < c->seg_count ; i++){
    print_segment(get_nth_segment(c,i));
  }
  printf("\n");
}

void release_cand_ent(struct cand_ent *c)
{
  if ( c->elm ){
    free(c->elm);
  }
  free_xstr_str(&c->str);
  free(c);
}

/*ʸꥹȤκǸǤ*/
void pop_back_seg_ent(struct anthy_context *c)
{
  struct seg_ent *s;
  s = c->seg_list.prev;
  if ( s == &c->seg_list){
    return ;
  }
  s->prev->next = s->next;
  s->next->prev = s->prev;
  if ( s->cands ){
    int i;
    for ( i = 0 ; i < s->cand_count ; i++){
      release_cand_ent(s->cands[i]);
    }
    free(s->cands);
  }
  free(s);
  c->seg_count --;
}
