#ifndef _context_h_included_
#define _context_h_included_

#include <xstr.h>
#include <dic.h>

#include "segment.h"

struct char_ent{
  xchar *c;
  int seg_border;
};

struct anthy_context{
  xchar *str;
  int char_count;/*ʸο*/
  struct char_ent *ce;/*ʸο+1(Хꥢʬ)ݤ*/
  int seg_count;
  struct seg_ent seg_list;
  dic_session_t dic_session;
  struct word_split_info_cache *word_split_info;/*Ω쥭å*/
};

struct anthy_context *create_context();
void context_set_str(struct anthy_context *c,xstr *x);
void reset_context(struct anthy_context *c);
void release_context(struct anthy_context *c);

void context_resize_segment(struct anthy_context *c,int nth,int resize);

void push_back_segment(struct anthy_context *c,struct seg_ent *s);

struct seg_ent *get_nth_segment(struct anthy_context *c,int );
int get_nth_segment_len(struct anthy_context *c,int sindex);

/* for debug */
void print_context(struct anthy_context *c);

#endif
