// ʸ⤷ñ򥻥åȤˤư
#include <stdlib.h>
#include <stdio.h>

#include "context.h"
#include "wordborder.h"

/**/
#define ASTAR_DEPTH 4
#define ASTAR_HEAP_DEPTH 2048
#define ASTAR_EXPAND_LIMIT 8192

struct Astar_node{
  struct meta_word *mw[ASTAR_DEPTH];
  int nr_mw;
  int score;
  int from;
  int len;
};

/*ǤҡפȤΤϸϤΤĤǤϤʤơ
  2ʬڤޤǡֹnλҤ2n2n+1ˤʤäƤơ
  ƤϻҥΡɤ礭ȤȤinvariant
  Ȥ뤳Ȥˤ롼ȥΡɤˤϺǤ¸ߤ롣
*/
static struct Astar_heap{
  struct Astar_node **heap;
  int nr_nodes;
}astar_heap;

static struct{
  struct Astar_node best;
  int best_score;
}search_stat;

/*metawordΤ*/
static void commit_metaword(struct meta_word *);
static struct meta_word *alloc_metaword();
static void print_metaword(struct meta_word *);

/*metaword*/
static void make_simple_metaword();
static void make_unkseq_metaword();
static void combine_metaword(struct meta_word *,struct meta_word *);

/**/
static void composite_metaword_constraint_check(struct meta_word *);

/*A*Ϣ*/
static int do_split(int ,int);
static void mark_by_metaword(struct meta_word *);
static struct Astar_node *alloc_astar_node();
static void init_astar_heap();
static void free_astar_heap();
static void rebalance_astar_heap_from_root(int );
static void push_astar_node(struct Astar_node *);
static struct Astar_node *pop_astar_node();
static void expand_astar_node(struct Astar_node *,int);
static void print_astar_node(struct Astar_node *);

/*ߡΥƥ*/
static struct anthy_context *g_context;
static struct word_split_info_cache *g_info;

void commit_metaword(struct meta_word *mw)
{
  mw->next = g_info->metawords[mw->from].next;
  g_info->metawords[mw->from].next = mw;
}

void print_metaword(struct meta_word *mw)
{
  printf("*meta word*\n");
  if ( mw->wl ){
    print_word_list(mw->wl);
  }
}

struct meta_word *alloc_metaword()
{
  struct meta_word *mw;
  mw = malloc(sizeof(struct meta_word));
  mw->type = MW_SINGLE;
  mw->score = 0;
  mw->wl = 0;
  mw->mw1 = 0;
  mw->mw2 = 0;
  mw->parent = 0;
  return mw;
}

void print_astar_node(struct Astar_node *n)
{
  int i;
  printf("A* node %d\n",n->score);
  for ( i = 0 ; i < n->nr_mw ; i++){
    print_metaword(n->mw[i]);
  }
  printf("\n");
}

struct Astar_node *alloc_astar_node()
{
  struct Astar_node *a = malloc(sizeof(struct Astar_node));
  a->nr_mw = 0;
  a->len = 0;
  return a;
}

void mark_by_metaword(struct meta_word *mw)
{
  if ( !mw ){
    return ;
  }
  switch(mw->type){
  case MW_NAMEPAIR:
    mark_by_metaword(mw->mw1);
    mark_by_metaword(mw->mw2);
    break;
  case MW_SINGLE:
  default:
    if ( mw->wl ){
      g_info->seg_border[mw->wl->from] = 1;
    }
  }
}


int do_split(int from,int to)
{
  struct Astar_node *a;
  int l,result;
  init_astar_heap();
  search_stat.best_score = 0;

  a = alloc_astar_node();
  a->from = from;
  push_astar_node(a);
  for ( l = ASTAR_EXPAND_LIMIT ; l >0 ; l--){
    a = pop_astar_node();
    if ( !a){
      goto out;
    }
    expand_astar_node(a,to);
  }
 out:

  if ( search_stat.best_score > 0 ){
    mark_by_metaword(search_stat.best.mw[0]);
    result = search_stat.best.mw[0]->len+from;
  }else{
    result = to;
  }

  free_astar_heap();

  return result;
}

void init_astar_heap()
{
  int i;
  if ( !astar_heap.heap ){
    astar_heap.heap = 
      malloc(sizeof(struct Astar_node *)*ASTAR_HEAP_DEPTH);
  }
  for ( i = 0 ; i < ASTAR_HEAP_DEPTH ; i++){
    astar_heap.heap[i] = 0;
  }
  astar_heap.nr_nodes = 0;
}

void free_astar_heap()
{
  int i;
  for ( i = 0 ; i < ASTAR_HEAP_DEPTH ; i++){
    if ( astar_heap.heap[i]){
      free(astar_heap.heap[i]);
    }
  }
  astar_heap.nr_nodes = 0;
}

void rebalance_astar_heap_from_root(int n)
{
  int l,r;
  int ls,rs,ns;
  struct Astar_node *nn,*ln,*rn;
  l = 2*(n+1)-1;
  r = 2*(n+1);
  ls = -2000000000;
  rs = -2000000000;
  ln = 0;
  rn = 0;
  ns = astar_heap.heap[n]->score;
  nn = astar_heap.heap[n];
  if ( l < ASTAR_HEAP_DEPTH ){
    ln = astar_heap.heap[l];
  }
  if ( r < ASTAR_HEAP_DEPTH ){
    rn = astar_heap.heap[r];
  }
  if ( ln ){
    ls = ln->score;
  }
  if ( rn ){
    rs = rn->score;
  }
  if ( ns > ls && ns > rs ){
    return ;
  }
  if ( ls > rs ){
    astar_heap.heap[n] = ln;
    astar_heap.heap[l] = nn;
    rebalance_astar_heap_from_root(l);
  }else{
    astar_heap.heap[n] = rn;
    astar_heap.heap[r] = nn;
    rebalance_astar_heap_from_root(r);
  }
}

void push_astar_node(struct Astar_node *a)
{
  int n,p;

  if ( astar_heap.nr_nodes >= ASTAR_HEAP_DEPTH-1 ){
    free(a);
    return ;
  }
  a->score = 0;
  for ( n = 0 ; n < a->nr_mw ; n++){
    a->score += a->mw[n]->score;
  }
  if ( a->nr_mw ){
    a->score /= a->nr_mw;
  }

  //print_astar_node(a);
  astar_heap.heap[astar_heap.nr_nodes] = a;
  astar_heap.nr_nodes ++;
  /*leaf¦rebalance*/
  n = astar_heap.nr_nodes -1;
  while(n){
    p = (n-1)/2;
    if ( astar_heap.heap[p]->score < astar_heap.heap[n]->score ){
      struct Astar_node *tmp;
      tmp = astar_heap.heap[p];
      astar_heap.heap[p] = astar_heap.heap[n];
      astar_heap.heap[n] = tmp;
    }
    n = p;
  }
}

struct Astar_node *pop_astar_node()
{
  struct Astar_node *n;
  n = astar_heap.heap[0];
  if ( !n ){
    return 0;
  }

  astar_heap.nr_nodes--;
  astar_heap.heap[0] = astar_heap.heap[astar_heap.nr_nodes];
  astar_heap.heap[astar_heap.nr_nodes] = 0;
  if ( astar_heap.nr_nodes ){
    /*root¦rebalance*/
    rebalance_astar_heap_from_root(0);
  }
  return n;
}

void expand_astar_node(struct Astar_node *a,int to)
{
  int t = a->from+a->len;
  int nr_expand = 0;

  /*Ÿ*/
  if ( a->nr_mw < ASTAR_DEPTH -1 && t <to ){
    struct meta_word *mw;
    for ( mw = g_info->metawords[t].next ; mw ; mw = mw->next ){
      if ( mw->can_use ){
	struct Astar_node *n = alloc_astar_node();
	*n = *a;
	n->mw[n->nr_mw] = mw;
	n->nr_mw++;
	n->len += mw->len;
	push_astar_node(n);
	nr_expand ++;
      }
    }
  }
  if ( nr_expand ==0 && a->score > search_stat.best_score ){
    search_stat.best_score = a->score;
    search_stat.best = *a;
  }
}

void composite_metaword_constraint_check(struct meta_word *mw)
{
}

void metaword_constraint_check(int from,int to)
{
  int i;
  /*ޤword_listľܻؤΤˤĤƥå*/
  for ( i = from ; i < to ; i ++ ){
    struct meta_word *mw;
    for ( mw = g_info->metawords[i].next ; mw ; mw = mw->next ){
      mw->can_use = 1;
      if ( mw->wl && !mw->wl->can_use){
	mw->can_use = 0;
      }
    }
  }
  /*˹줿metawordˤĤƥå*/
  for ( i = from ; i < to ; i ++ ){
    struct meta_word *mw;
    for ( mw = g_info->metawords[i].next ; mw ; mw = mw->next ){
      if ( !mw->wl ){
	composite_metaword_constraint_check(mw);
      }
    }
  }
}

void make_unkseq_metaword()
{
  int i;
  int *p = alloca(sizeof(int)*g_context->char_count);
  for ( i = 0 ; i < g_context->char_count ; i ++){
    p[i] = 0;
  }
  /*metawordˤäƥСƤΰޡ*/
  for ( i = 0 ; i < g_context->char_count ; i++){
    struct meta_word *mw;
    for ( mw = g_info->metawords[i].next ; mw ; mw = mw->next ){
      int j;
      for ( j = 0 ; j < mw->len ; j++){
	p[i+j] = 1;
      }
    }
  }
  /*ޡƤʤʬޡ*/
  for ( i = 0 ; i < g_context->char_count ; i++){
    if ( !p[i] ){
      int j = 0;
      struct meta_word *mw = alloc_metaword();
      mw->from = i;
      for ( ; i < g_context->char_count && !p[i] ; i++,j++);
      mw->len = j;
      commit_metaword(mw);
    }
  }
  /*̤ΤεȤ̵ʸѥ롣*/
  for ( i = 0 ; i < g_context->char_count ; i++ ){
    if ( !g_info->metawords[i].next){
      struct meta_word *mw = alloc_metaword();
      mw->from = i;
      mw->len = 0;
      commit_metaword(mw);
    }
  }
}

void make_simple_metaword()
{
  int i;
  for ( i = 0 ; i < g_context->char_count ; i++){
    struct word_list *wl;
    for ( wl = g_info->lists[i].next ; wl ; wl = wl->next ){
      struct meta_word *mw = alloc_metaword();
      mw->wl = wl;
      mw->from = wl->from;
      mw->len = wl->len;
      mw->score = wl->score+wl->len*10000;
      mw->type = MW_SINGLE;
      commit_metaword(mw);
    }
  }
}

void release_metaword_list()
{
  int i;
  for ( i = 0 ; i < g_context->char_count ; i ++){
    struct meta_word *mw;
    for ( mw = g_info->metawords[i].next ; mw ; ){
      struct meta_word *tmp;
      tmp = mw;
      mw = mw->next;
      free(tmp);
    }
  }
}

/*٤metawordȷǤ뤫å*/
void combine_metaword(struct meta_word *mw,struct meta_word *mw2)
{
  if ( mw->wl && mw2->wl ){
    if ( mw->wl->postfix_len + mw->wl->follow_count == 0 
	 && mw->wl->prefix_len == 0
	 && mw2->wl->prefix_len == 0){
      struct meta_word *n;
      int f,f2;
      f = get_seq_flag(mw->wl->core_seq);
      f2 = get_seq_flag(mw2->wl->core_seq);
      if ( (f & NF_FAMNAME) && (f2 & NF_FSTNAME)){
	n = alloc_metaword();
	n->from = mw->from;
	n->len = mw->len + mw2->len;
	n->score = (mw->score + mw2->score)/2;
	n->type = MW_NAMEPAIR;
	n->mw1 = mw;
	n->mw2 = mw2;
	commit_metaword(n);
      }
    }
  }
}

void make_metaword_list(struct anthy_context *ac)
{
  int i;

  g_context = ac;
  g_info = ac->word_split_info;

  /*ޤword_listämetaword*/
  make_simple_metaword();

  /*̤ʸ򥫥Сmetaword*/
  make_unkseq_metaword();

  /*礹*/
  for ( i = 0 ; i < g_context->char_count ; i++){
    struct meta_word *mw,*mw2;
    for ( mw = g_info->metawords[i].next ; mw ; mw = mw->next ){
      if ( mw->len + i < g_context->char_count ){
	for ( mw2 = g_info->metawords[mw->len+i].next ; 
	      mw2 ; mw2 = mw2->next ){
	  combine_metaword(mw,mw2);
	}
      }
    }
  }
}

void eval_border(int from,int to)
{
  do{
    from = do_split(from,to);
  }while(from < to );
}
