/*°*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <conf.h>
#include <ruleparser.h>
#include <xstr.h>
#include "wordborder.h"

static int nrNodes;

struct dep_branch{
  /*ܾ°*/
  int nr_strs;
  xstr *str;
  /*ΥΡ*/
  int nr_nexts;
  int *next;
};

static struct dep_node{
  char *cn;/*Ρɤ̾*/
  int nr_branch;
  struct dep_branch *branch;
}*gNodes;

static void parse_line(char **,int );
static void match_nodes(struct word_list *,xstr xs,int node,int len);
static void match_branch(struct word_list *wl,xstr *xs,struct dep_branch *,int len,int wlen);
static void check_nodes();

void check_nodes()
{
  int i;
  for ( i = 1 ; i < nrNodes ; i++){
    if ( gNodes[i].nr_branch == 0 ){
      printf("node %s has no branch.\n",gNodes[i].cn);
    }
  }
}

void match_branch(struct word_list *tmpl,xstr *xs,struct dep_branch *db,int len,int wlen)
{
  int k;
  /*˥ȥ饤*/
  for ( k = 0 ; k < db->nr_nexts ; k++){
    if ( db->next[k] ){
      xstr f;
      f.str = &xs->str[wlen];
      f.len = xs->len - wlen;
      match_nodes(tmpl,f,db->next[k],len+wlen);
    }else{
      /*üΡɤã*/
      struct word_list *wl;
      wl = malloc(sizeof(struct word_list));
      *wl = *tmpl;
      wl->len += len+ wlen;
      commit_word_list(wl);
    }
  }
}

void match_nodes(struct word_list *wl,xstr follow_str,int node,int len)
{
  struct dep_node *dn=&gNodes[node];
  struct dep_branch *db;
  int i,j;
  /*ƥ롼*/
  for ( i = 0 ; i < dn->nr_branch ; i++){
    db = &dn->branch[i];
    /*ܾ*/
    for ( j = 0 ; j < db->nr_strs ; j++){
      if ( follow_str.len >= db->str[j].len ){
	xstr w;
	w.str = follow_str.str;
	w.len = db->str[j].len;
	if (!xstrcmp(&w,&db->str[j])){
	  wl->follow_count += w.len;
	  match_branch(wl,&follow_str,db,len,w.len);
	  wl->follow_count -= w.len;
	}
      }
    }
  }
}

void scan_node(struct word_list *tmpl,xstr *follow,int node)
{
  /*°դƤʤ֤鸡򳫻Ϥ*/
  match_nodes(tmpl,*follow,node,0);
}

int get_node_id_by_name(char *name)
{
  int i;
  for ( i = 0 ; i < nrNodes ; i++){
    if (! strcmp(name,gNodes[i].cn)){
      return i;
    }
  }
  gNodes = realloc(gNodes,sizeof(struct dep_node)*(nrNodes+1));
  gNodes[nrNodes].cn = strdup(name);
  gNodes[nrNodes].nr_branch = 0;
  gNodes[nrNodes].branch = 0;
  nrNodes++;
  return nrNodes-1;
}

void parse_line(char **tokens,int nr)
{
  int id,i;
  struct dep_branch *db;
  struct dep_node *dn;
  /*̾ΥΡɤ*/
  id = get_node_id_by_name(tokens[0]);
  dn = &gNodes[id];

  /*branchɲä*/
  dn->branch = realloc(dn->branch,sizeof(struct dep_branch)*(dn->nr_branch+1));
  db = &dn->branch[dn->nr_branch];
  dn->nr_branch++;
  db->nr_strs = 0;
  db->str = 0;
  db->nr_nexts = 0;
  db->next = 0;

  /*Υ֥°ΥꥹȤɲä*/
  for ( i = 1 ; i < nr && tokens[i][0] == '\"' ; i++){
    char *s;
    xstr *xs;
    s = strdup(&tokens[i][1]);
    s[strlen(s)-1] =0;
    xs = cstr_to_xstr(s);
    db->str = realloc(db->str,sizeof(xstr)*(db->nr_strs+1));
    db->str[db->nr_strs] = *xs;
    db->nr_strs ++;
    free(s);
    free(xs);
  }
  /*ΥΡɤɲä*/
  for ( ; i < nr ; i++){
    int next_id;
    next_id = get_node_id_by_name(tokens[i]);
    db->next = realloc(db->next,sizeof(int)*(db->nr_nexts+1));
    db->next[db->nr_nexts] = next_id;
    db->nr_nexts ++;
  }
}

int init_depword_tab()
{
  char *fn;
  char **tokens;
  int nr;
  /*id 0 Ρɤ˳Ƥ*/
  get_node_id_by_name("@");
  fn = conf_get_str("DEPWORD");
  if (!fn ){
    printf("dep word dict unspecified.\n");
    return -1;
  }
  if ( open_file(fn) == -1 ){
    printf("failed to open dep word dict (%s).\n",fn);
    return -1;
  }
  while(!read_line(&tokens,&nr)){
    parse_line(tokens,nr);
    free_line();
  }
  close_file();
  check_nodes();
  return 0;
}
