/*
  splitter
  mark_borderΤߤƤФ
*/

//#define DEBUG_CONJUGATE_TABLE

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <wtype.h>
#include <conf.h>
#include <ruleparser.h>
#include "main.h"
#include "context.h"
#include "wordborder.h"

/*ȥƥ*/
static struct anthy_context *g_context;
static struct word_split_info_cache *g_info;
static int g_len;/*ʸοʤΤ*/

/*ñ³롼*/
static struct wordseq_rule{
  wtype_t wt;
  char *name;/*ʻ̾(ǥХå)*/
  int node_id;
  struct wordseq_rule *next;
}gRules;

struct seg_cand{
  struct word_list *wl;
  int from,len;
};

/*Rule*/
static void seg_constraint_check(int ,int );
static void make_word_cache();
static void make_word_tree(seq_ent_t se,int from,int len);
static void make_pre_words(seq_ent_t se,struct word_list *);
static void make_suc_words(seq_ent_t se,struct word_list *);
static void make_following_word_list(seq_ent_t se,struct word_list *);
static void parse_line(char **,int nr);
static int calc_suffix_affinity(seq_ent_t core,seq_ent_t suffix,int suc);

/**/
void mark_segment_border(struct anthy_context *,int ,int,int );

/*ǥХå*/
void print_word_list(struct word_list *wl)
{
  xstr xs;
  if ( !wl ){
    printf("--\n");
    return ;
  }
  /*prefix*/
  xs.len = wl->core_from - wl->from;
  xs.str = &g_context->str[wl->from];
  putxstr(&xs);
  printf(".");
  /*core*/
  xs.len = wl->core_len;
  xs.str = &g_context->str[wl->core_from];
  putxstr(&xs);
  printf(".");
  /*suffix*/
  xs.len = wl->len - ( wl->core_from - wl->from + wl->core_len);
  xs.str = &g_context->str[wl->core_from+wl->core_len];
  putxstr(&xs);
  printf(" %d %d %d\n",wl->prefix_len,wl->postfix_len,wl->score);
}

/*äword_list򥳥ߥåȤ*/
void commit_word_list(struct word_list *wl)
{
  int len = wl->core_len;
  int f = ffs(wl->freq)+3;
  if ( f > 8 ){
    f = 8;
  }
  wl->score += 5*len*len*len*len*f;

  /*ƬФ븺*/
  if ( wl->postfix_len ||  wl->prefix_len ){
    wl->score -= 5000;
  }
  
  /*°Ф*/
  if ( wl->follow_count ){
    wl->score += 500*wl->follow_count;
  }

  wl->score += wl->len*10000;

  wl->next = g_info->lists[wl->from].next;
  g_info->lists[wl->from].next = wl;
  //print_word_list(wl);
}

int calc_suffix_affinity(seq_ent_t core,seq_ent_t suf,int isSuc)
{
  int a=0;
  if ( ( get_seq_flag(suf) & SF_NUM )&&
       ( get_seq_flag(core) & NF_NUM )){
    a += 5000;
  }
  if ( isSuc &&
       ( get_seq_flag(suf) & SF_JN)&&
       ( get_seq_flag(core) & NF_NAME)){
    a+= 5000;
  }
       
  return a;
}

/*³ν졢ưդ
 */
void make_following_word_list(seq_ent_t se,struct word_list *tmpl)
{
  struct wordseq_rule *r;
  /*ƥ롼˥ޥåƤ뤫ɤĴ٤Ƥ*/
  for ( r = gRules.next ; r ; r = r->next ){
    int freq = get_seq_ent_wtype_freq(se,r->wt);
    if (freq){
      /*ΩʻϤäƤ*/
      xstr xs;
#ifdef DEBUG_CONJUGATE_TABLE
      xs.str = &g_context->str[tmpl->core_from];
      xs.len = tmpl->core_len;
      putxstr(&xs);
      printf(" %s\n",r->name);
#endif
      xs.str = &g_context->str[tmpl->from+tmpl->len];
      xs.len = g_len- tmpl->from - tmpl->len;
      tmpl->freq = freq;
      scan_node(tmpl,&xs,r->node_id);
    }
  }
}

/*򤯤äĤ*/
void make_suc_words(seq_ent_t se,struct word_list *tmpl)
{
  int i;
  for ( i = 1 ; i <= g_info->seq_len[tmpl->core_from+tmpl->core_len];
	i++){
    xstr xs;
    seq_ent_t s;
    xs.str = &g_context->str[tmpl->core_from+tmpl->core_len];
    xs.len = i;
    s = get_seq_ent_from_xstr(&xs);
    if ( get_seq_ent_pos(s,POS_SUC)){
      struct word_list new_tmpl;
      new_tmpl = *tmpl;
      new_tmpl.len += i;
      new_tmpl.postfix_len += i;
      new_tmpl.score += calc_suffix_affinity(new_tmpl.core_seq,s,1);
      make_following_word_list(se,&new_tmpl);
    }
  }
}

/*Ƭ򤯤äĤ*/
void make_pre_words(seq_ent_t se,struct word_list *tmpl)
{
  int i;
  /*Ƭ󤹤*/
  for ( i = 1 ; i <= g_info->rev_seq_len[tmpl->core_from] ;i++){
    xstr xs;
    seq_ent_t s;
    xs.str = &g_context->str[tmpl->core_from-i];
    xs.len = i;
    s = get_seq_ent_from_xstr(&xs);
    if ( get_seq_ent_pos(s,POS_PRE)){
      struct word_list new_tmpl;
      new_tmpl = *tmpl;
      new_tmpl.from = tmpl->from - i;
      new_tmpl.len = tmpl->len +i;
      new_tmpl.score += calc_suffix_affinity(new_tmpl.core_seq,s,0);
      new_tmpl.prefix_len += i;
      make_following_word_list(se,&new_tmpl);
      if ( get_seq_flag(se) & NF_NUM ){
	/*ξ⤯äĤ롣*/
	make_suc_words(se,&new_tmpl);
      }
    }
  }
}

/*ΩФơƬ°դΤ
 ʸθ(=word_list)Ȥcacheɲä롣*/
void make_word_tree(seq_ent_t se,int from,int len)
{
  struct word_list tmpl;
  struct word_list *l;

  tmpl.from = from;
  tmpl.len = len;
  tmpl.core_from = from;
  tmpl.core_len = len;
  tmpl.postfix_len = 0;
  tmpl.prefix_len = 0;
  tmpl.follow_count = 0;
  tmpl.core_seq = se;
  tmpl.score = 0;
  /*μΩΤߤʸɲ*/
  l = malloc(sizeof(struct word_list));
  *l = tmpl;
  commit_word_list(l);
  
  /*°ΥꥹȤ롣*/
  if ( get_seq_ent_pos(se,POS_NOUN)){
    /*Ƭ̾ˤդʤȤˤƤ*/
    make_pre_words(se,&tmpl);
    make_suc_words(se,&tmpl);
  }
  make_following_word_list(se,&tmpl);
}

/*ʸᶭ­ʤʸ롣*/
void seg_constraint_check(int from,int to)
{
  int i,j;
  for ( i = from ; i < to ; i++){
    struct word_list *wl;
    for ( wl = g_info->lists[i].next ; wl ; wl = wl->next ){
      wl->can_use = 1;
      for (j = 1 ; j < wl->len ; j++){
	if ( g_context->ce[i+j].seg_border ){
	  wl->can_use = 0;
	}
      }
    }
  }
  metaword_constraint_check(from,to);
}

/*ǳݤƤrelease_info_cacheǲ롣*/
void make_word_cache()
{
  int i,j;
  xstr xs;
  seq_ent_t se;
  struct depword_ent{
    struct depword_ent *next;
    int from,len;
    seq_ent_t se;
  }head,*de;
  head.next = 0;

  g_context->word_split_info = malloc(sizeof(struct word_split_info_cache));
  g_info = g_context->word_split_info ;
  g_info->lists = malloc(sizeof(struct word_list)*(g_len+1));
  g_info->metawords = malloc(sizeof(struct meta_word)*(g_len+1));

  g_info->seq_len = malloc(sizeof(int)*(g_len+1));
  g_info->rev_seq_len = malloc(sizeof(int)*(g_len+1));

  /*ХꥢΤȤޤǽ*/
  for ( i = 0 ; i <= g_len ; i++){
    g_info->seq_len[i] = 0;
    g_info->rev_seq_len[i] = 0;
    g_info->lists[i].next = 0;
    g_info->metawords[i].next = 0;
  }

  /*ƤμΩ*/
  /*ʸĹΥ롼*/
  for ( i = g_len; i > 0 ; i--){
    if ( i > 30 ){
      continue;
    }
    /*Υ롼*/
    for ( j = 0; j <= g_len -i ; j++){
      xs.len = i;
      xs.str = &g_context->str[j];
      se = get_seq_ent_from_xstr(&xs);
      if (se ){
	/*ơʬʸñʤ*/
	if ( i > g_info->seq_len[j] ){
	  g_info->seq_len[j] = i;
	}
	if ( i > g_info->rev_seq_len[j+i] ){
	  g_info->rev_seq_len[i+j] = i;
	}
	/*ȯΩꥹȤɲ*/
	if (get_seq_ent_indep(se)){
	  de = (struct depword_ent *)malloc(sizeof(struct depword_ent));
	  de->from = j;
	  de->len = i;
	  de->se = se;
	  de->next = head.next;
	  head.next = de;
	}
      }
    }
  }

  /*ȯΩƤФ°ѥθ*/
  for ( de = head.next ; de ; ){
    struct depword_ent *tmp;
    make_word_tree(de->se,de->from,de->len);
    tmp = de->next;
    free(de);
    de = tmp;
  }

  make_metaword_list(g_context);
}

void release_info_cache(struct word_split_info_cache *c)
{
  int i;
  struct word_list *wl;

  release_metaword_list();

  for ( i = 0 ; i < g_len ; i++){
    for ( wl = c->lists[i].next ; wl ; ){
      struct word_list *tmp;
      tmp = wl;
      wl = wl->next;
      free(tmp);
    }
  }
  free(c->lists);
  free(c->seq_len);
  free(c->rev_seq_len);
}

void parse_line(char **tokens,int nr)
{
  struct wordseq_rule *r;
  if ( nr < 2 ){
    printf("Syntex error in indepword defs.\n");
    return ;
  }
  /*ԤƬˤʻ̾äƤ*/
  r = malloc(sizeof(struct wordseq_rule));
  r->name = strdup(tokens[0]);
  name_to_wtype(tokens[0],&r->wt);
  /*μˤϥΡ̾äƤ*/
  r->node_id = get_node_id_by_name(tokens[1]);
  /*롼ɲ*/
  r->next = gRules.next;
  gRules.next = r;
}

void release_word_split_info(struct anthy_context *ac)
{
  if ( !ac->word_split_info){
    return ;
  }
  release_info_cache(ac->word_split_info);
  free(ac->word_split_info);
  ac->word_split_info = 0;
}

void mark_segment_border(struct anthy_context *c,int from,int to,int resize)
{
  int i,n;
  struct seg_ent *s;
  for ( i = from ; i < to ; i++){
    c->ce[i].seg_border = g_info->seg_border[i];
  }
  /**/
  for ( i = 0,n = 0 ; i < from ; i += get_nth_segment_len(c,n) , n++);
  for ( i = from ; i < to ; i++){
    if(c->ce[i].seg_border ){
      s = (struct seg_ent *)malloc(sizeof(struct seg_ent));
      s->str.str = &c->str[i];
      s->str.len = get_nth_segment_len(c,n);
      s->cand_count = 0;
      s->cands = 0;
      s->resized = 0;
      if ( i == from && resize ){
	s->resized = 1;
      }
      push_back_segment(c,s);
      n++;
    }
  }
}

int init_word_seq_tab()
{
  char *fn;
  char **tokens;
  int nr;
  if ( init_depword_tab() ){
    printf("failed to init dependent word table.\n");
    return -1;
  }
  fn = conf_get_str("INDEPWORD");
  if (!fn){
    printf("indep word dict unspecified.\n");
    return -1;
  }
  if (open_file(fn) == -1 ){
    printf("failed to open indep word dict (%s).\n",fn);
    return -1;
  }
  gRules.next = 0;
  while( !read_line(&tokens,&nr)){
    parse_line(tokens,nr);
    free_line();
  }
  close_file();
  return 0;
}

/*ƤӽФwordsplitterΥȥåץ٥δؿ*/
void mark_border(struct anthy_context *c,int from,int from2,int to)
{
  int i,j=0;

  if ( (to-from) == 0 ){
    return ;
  }

  g_context = c;
  g_len = g_context->char_count;

  /*ΥƥΩʤɤξ򥭥å夹
    ܤ¹Ԥ*/
  if ( !g_context->word_split_info ){
    make_word_cache();
  }
  g_info = g_context->word_split_info ;
  g_info->seg_border = alloca(sizeof(int)*(c->char_count+1));
  for ( i = 0 ; i < c->char_count+1 ; i++){
    g_info->seg_border[i] = c->ce[i].seg_border;
  }

  /*ʸΤȤΤΤ*/
  seg_constraint_check(from,to);

  eval_border(from,to);
  for ( i = from+1 ; i < from2 ; i++){
    g_info->seg_border[i] = 0;
  }
  if ( from == from2 ){
    j = 1;
  }
  mark_segment_border(c,from,to,1);
}
