// -*- C++ -*-
#ifndef _anthyconv_h_included_
#define _anthyconv_h_included_

#include <anthy.h>
#include <list>

#include "converter.h"

class RKConv;
class RKMap;

typedef int jchar;
typedef list<jchar> jstring;

static char *jstring_to_str(jstring *);
static void str_to_jstring(jstring *,char *);
static void clear_jstring(jstring *);
static void append_jstring(jstring *,jstring *);
static void print_jchar(jchar );
static void print_jstring(jstring *);

/*AnthyConv::mMode*/
#define RAW_MODE 0
#define INPUT_MODE 1
#define COMPOSE_MODE 2

struct segment{
  int cur_cand;
  vector<jstring> cands;
};

class AnthyConv : public Converter {
public:
  AnthyConv(anthy_context_t );
  virtual ~AnthyConv();
  int proc_key(keyEvent *);
  void get_preedit(preedit *);
  STRING get_pending();
  STRING get_status();
private:
  int proc_raw_mode(keyEvent *);
  int proc_input_mode(keyEvent *);
  int proc_compose_mode(keyEvent *);
  void do_conv();
  void do_commit();
  void update_anthy_stat(int );
  
  int mMode;
  RKConv *mRkConv;
  anthy_context_t mAC;
  jstring mStr;
  vector<segment> mSegs;
  int mCurSeg;
  jstring mCommit;
};

AnthyConv *create_anthy_context();

extern RKMap *rk_hira_map;
extern RKMap *rk_kata_map;

#endif
