// -*- C++ -*-
#ifndef _converter_h_included_
#define _converter_h_included_

#include <vector>
#include "packet.h"

struct keyEvent;
struct preedit;

/*proc_input$B$NJV$jCM(B*/
#define DO_NOTHING 0
#define COMMIT_RAW 1
#define UPDATE_PREEDIT 2
#define COMMIT_PENDING 4
#define UPDATE_STATUS 8

/*pe_string::stat*/
#define NORMAL_VIDEO 0
#define REVERSE_VIDEO 1
#define UNDERLINE_VIDEO 2

struct pe_string{
  int stat;
  STRING str;
};

struct preedit{
  vector<pe_string>segs;
};

class Converter{
public:
  virtual ~Converter();
  virtual int proc_key(keyEvent *)=0;
  virtual void get_preedit(preedit *)=0;
  virtual STRING get_pending()=0;
  virtual STRING get_status()=0;
};

Converter *create_converter();

#endif
