// keybind
#include <stdio.h>
#include <list>
#define KEYATOMS
#include "keybind.h"

static const int ANY_KEY = 0;

class Atom{
public:
  Atom(int code,int ch,int mod){
    addBind(code,ch,mod);
  }
  bool isMatch(int code,int ch,int mod){
    list<keyEvent>::iterator it;
    for ( it = mBinds.begin() ; it != mBinds.end() ; it++){
      keyEvent ev = *it;
      if ( (ev.keycode == code || ev.keycode == ANY_KEY)&& 
	     (ev.keychar == ch || ev.keychar == ANY_KEY)&& 
	     ev.modifier == mod ){
	return true;
      }
    }
    return false;
  }
  void addBind(int code,int ch,int mod){
    keyEvent ev;
    ev.keycode = code;
    ev.keychar = ch;
    ev.modifier = mod;
    mBinds.push_back(ev);
  }
private:
  list<keyEvent> mBinds;
};

void initKeyAtoms()
{
  A_do_conv = new Atom(' ',' ',MOD_NONE);
  A_cancel = new Atom('G',ANY_KEY,MOD_CTRL);
  A_next_segment = new Atom('F',ANY_KEY,MOD_CTRL);
  A_prev_segment = new Atom('B',ANY_KEY,MOD_CTRL);
  A_commit = new Atom('\n','\n',MOD_NONE);
  A_expand_segment = new Atom('O',ANY_KEY,MOD_CTRL);
  A_shorten_segment = new Atom('I',ANY_KEY,MOD_CTRL);
  A_next_candidate = new Atom('N','n',MOD_SHIFT);
  A_delete_back = new Atom(8,8,0);

  A_expand_segment->addBind(39,ANY_KEY,MOD_SHIFT);
  A_shorten_segment->addBind(37,ANY_KEY,MOD_SHIFT);
  A_commit->addBind('J',ANY_KEY,MOD_CTRL);
  A_delete_back->addBind('H',ANY_KEY,MOD_CTRL);
  A_next_candidate->addBind(' ',ANY_KEY,MOD_NONE);
}

bool isBindTo(keyEvent *ev,keyAtom a)
{
  ev->print();
  return a->isMatch(ev->keycode,ev->keychar,ev->modifier);
}

void keyEvent::print()
{
  printf("code = %d,char = %d,mod = %d,stamp = %d\n",
	 keycode,keychar,modifier,timestamp);
}
